fastboot $* getvar product 2>&1 | grep "^product: *violet$"
if [ $? -ne 0 ] ; then echo "Missmatching image and device"; exit 1; fi

CURRENT_ANTI_VER=1
anti=`fastboot getvar anti 2>&1 | grep anti: | cut -f 2 -d ' '`
if [ -z "$anti" ];then
    anti=0
fi
if [ $anti -eq $CURRENT_ANTI_VER ]; then
    # reflash
    fastboot $* flash antirbpass `dirname $0`/images/dummy.img || exit 1
elif [ $anti -gt $CURRENT_ANTI_VER ]; then
    # downgrade
    echo "downgrade not allowed!!!"
    exit 1
fi

fastboot $* flash xbl  `dirname $0`/images/xbl.elf
fastboot $* flash xblbak   `dirname $0`/images/xbl.elf
fastboot $* flash xbl_config  `dirname $0`/images/xbl_config.elf
fastboot $* flash imagefv  `dirname $0`/images/imagefv.elf

fastboot $* flash aop   `dirname $0`/images/aop.mbn

fastboot $* flash tz   `dirname $0`/images/tz.mbn
fastboot $* flash tzbak   `dirname $0`/images/tz.mbn
fastboot $* flash devcfg   `dirname $0`/images/devcfg.mbn
fastboot $* flash devcfgbak   `dirname $0`/images/devcfg.mbn
fastboot $* flash hyp   `dirname $0`/images/hyp.mbn
fastboot $* flash hypbak   `dirname $0`/images/hyp.mbn

fastboot $* flash keymaster   `dirname $0`/images/km4.mbn
fastboot $* flash keymasterbak   `dirname $0`/images/km4.mbn
fastboot $* flash cmnlib   `dirname $0`/images/cmnlib.mbn
fastboot $* flash cmnlibbak   `dirname $0`/images/cmnlib.mbn
fastboot $* flash cmnlib64   `dirname $0`/images/cmnlib64.mbn
fastboot $* flash cmnlib64bak   `dirname $0`/images/cmnlib64.mbn
fastboot $* flash uefisecapp   `dirname $0`/images/uefi_sec.mbn
fastboot $* flash uefisecappbak   `dirname $0`/images/uefi_sec.mbn
fastboot $* flash storsec   `dirname $0`/images/storsec.mbn
fastboot $* flash storsecbak   `dirname $0`/images/storsec.mbn

fastboot $* flash modem   `dirname $0`/images/NON-HLOS.bin
fastboot $* flash dsp   `dirname $0`/images/dspso.bin
fastboot $* flash bluetooth   `dirname $0`/images/BTFM.bin
fastboot $* flash qupfw   `dirname $0`/images/qupv3fw.elf
fastboot $* flash multiimgoem   `dirname $0`/images/multi_image.mbn

fastboot $* flash abl   `dirname $0`/images/abl.elf
fastboot $* flash ablbak   `dirname $0`/images/abl.elf

fastboot $* flash boot   `dirname $0`/images/boot.img
fastboot $* flash dtbo   `dirname $0`/images/dtbo.img
fastboot $* flash recovery   `dirname $0`/images/recovery.img
fastboot $* flash system   `dirname $0`/images/system.img
fastboot $* flash vendor   `dirname $0`/images/vendor.img
fastboot $* flash vbmeta   `dirname $0`/images/vbmeta.img
fastboot $* flash cache   `dirname $0`/images/cache.img
fastboot $* flash splash   `dirname $0`/images/splash.img

fastboot $* erase ddr
fastboot $* erase misc
fastboot $* erase apdp

fastboot $* flash cust `dirname $0`/images/cust.img

fastboot $* reboot
